﻿namespace FactoryMethod
{
    class Camera
    {
        Lens lens;
        public Camera()
        {
            lens = null;
        }

        public Lens PutInLens(Lens lens)
        {
            Lens oldlens = this.lens;
            this.lens = lens;
            return oldlens;
        }
        public Lens GetOutLens()
        {
            return PutInLens(null);
        }
        public void TakePicture(Distance distance)
        {
            lens.Take(distance);
        }
        public int GetZoomLevel()
        {
            if(lens!=null)
            {
                return lens.ZoomLevel;
            }
            return -1;
        }

        public int ZoomIn()
        {
            if(lens!=null)                
            {	
                MFLens mflens = lens as MFLens;
                if(mflens!=null)
                {
                    mflens.ZoomIn();
                }
                return lens.ZoomLevel;
            }        
            return -1;        
        }
        public int ZoomOut()
        {
            if (lens!=null)
            {
                MFLens mflens = lens as MFLens;
                if (mflens!=null)
                {
                    mflens.ZoomOut();
                }
                return lens.ZoomLevel;
            }
            return -1;
        }
    }
}
