﻿

namespace FactoryMethod
{
    class FocusController
    {
        public int Zoomlevel
        {
            get;
            private set;
        }
        readonly int minzoomlevel;        
        readonly int maxzoomlevel;
        public static readonly FocusController EmptyController;        
        static FocusController()
        {
            EmptyController = new FocusController(-1,-1,-1);
        }
        public FocusController(int zoomlevel, int minzoomlevel, int maxzoomlevel)
        {
            Zoomlevel = zoomlevel;
            this.minzoomlevel = minzoomlevel;
            this.maxzoomlevel = maxzoomlevel;
        }
        public bool EnableZoom()
        {
            return Zoomlevel != -1;
        }
        public int ZoomIn(int lv)
        {
            if(EnableZoom())
            {
                if (Zoomlevel < lv) 
                { 
                    Zoomlevel++; 
                }		
            }
            return Zoomlevel;
        }
        public int ZoomOut(int lv)
        {
            if(EnableZoom())
            {
                if (lv < Zoomlevel) 
                { 
                    Zoomlevel--; 
                }		
            }
            return Zoomlevel;
        }
        
        public int GetMinZoomLevel()    
        {    
            return minzoomlevel;    
        }
        public int GetMaxZoomLevel()    
        {    
            return maxzoomlevel;     
        }
    }
}
