﻿using System;

namespace FactoryMethod
{
    enum Distance
    {
        NA,  FAR=1,  MIDDLE=4,  NEAR=9	
    };
    class Lens
    {
        FocusController fc = FocusController.EmptyController;
        public int ZoomLevel
        {
            get
            {
                return fc.Zoomlevel;
            }
        }
        public bool EnableZoom
        {
            get
            {
                return fc.EnableZoom();
            }
        }
        public virtual bool AutoFocusable()
        {
            return false;
        }
        public void Take(Distance distance)
        {	
            if(AutoFocusable())
            {
                AutoFocus(distance);		
            }
            Console.WriteLine("Zoom Level:{0} 사진이 잘 나왔나요?", ZoomLevel);            
        }
        protected FocusController GetFocusController()
        {
            if (EnableZoom)
            {
                return fc;
            }
            return FocusController.EmptyController;
        }
        protected void SetFocusController(FocusController fc)
        {
            this.fc = fc;
        }
        protected void IncreZoomLevel(int zl)
        {	
            while(zl > fc.Zoomlevel)
            {
                fc.ZoomIn(zl);
            }
        }
        protected void DecreZoomLevel(int zl)
        {
            while(zl < fc.Zoomlevel)
            {
                fc.ZoomOut(zl);
            }
        }
        public virtual void AutoFocus(Distance distance)
        {	
        }
    }
}
