﻿using System;

namespace FactoryMethod
{
    class Photographer
    {
        Camera camera;
        ICreateLens[] lcs = new ICreateLens[3];
        Lens[] lenses = new Lens[3];
        public Photographer()
        {
            InitSimulation();
        }

        private void InitSimulation()
        {
            camera = new Camera();
            lcs[0] = new AFLensCreator();
            lcs[1] = new MFLensCreator();
            lcs[2] = new NAFLensCreator();
            lenses[0] = lcs[0].MakeLens();
            lenses[1] = lcs[1].MakeLens();
            lenses[2] = lcs[2].MakeLens();            
        }
        public void RunSimulation()
        {
            foreach (Lens lens in lenses)
            {
                TestLens(lens);
            }
        }

        private void TestLens(Lens lens)
        {
            Console.WriteLine("--------렌즈 테스트--------");
            camera.PutInLens(lens);
            camera.TakePicture(Distance.NEAR);
            camera.TakePicture(Distance.MIDDLE);
            camera.TakePicture(Distance.FAR);

            Console.WriteLine("수동으로 ZoomIn 시도");
            camera.ZoomIn();
            camera.TakePicture(Distance.NEAR);
            camera.TakePicture(Distance.MIDDLE);
            camera.TakePicture(Distance.FAR);

            Console.WriteLine("수동으로 ZoomOut 2회 시도");
            camera.ZoomOut();
            camera.ZoomOut();
            camera.TakePicture(Distance.NEAR);
            camera.TakePicture(Distance.MIDDLE);
            camera.TakePicture(Distance.FAR);
        }
    }
}
